import processing.video.*;
import blobDetection.*;

Capture cam;
PFont f;

boolean ladyAda[] = {false,false,false,false,false,false,false,false}; // tableau avec des valeurs booléennes

int asciiVal = 0;
int vieuxAscii;
String leMot = "";

// blob detection
BlobDetection theBlobDetection;
boolean newFrame=false;

int multiplier = 75;
int offsetX = 37;
int offsetY = 210;
int widthX = 50;
int widthY = 60;

int countBlob = 0;

void setup() {
  size(640, 480);
  background(0);
  
  // Create the font
  printArray(PFont.list());
  f = createFont("Helvetica", 18);
  textFont(f);

  String[] cameras = Capture.list();
  cam = new Capture(this, 640, 480, cameras[0]);  // Changez votre caméra ici camera[0], camera[1], etc.
  cam.start();
  
  // BlobDetection  
  theBlobDetection = new BlobDetection(640, 480);
  theBlobDetection.setPosDiscrimination(true);
  theBlobDetection.setThreshold(0.7f); // will detect bright areas whose luminosity > 0.7f;
}

void draw() {
  if (cam.available() == true) {
    cam.read();
  }
    
  loadPixels();
  cam.loadPixels();
  // The following does the same as the above image() line, but 
  // is faster when just drawing the image without any additional 
  // resizing, transformations, or tint. // faire la moyenne des pixels en grille de 16 ?
  // les afficher comme ça
  // transférer en noir et blanc
  for (int x = 0; x < width ; x+=10){ // x++
    for (int y = 0; y < height ; y+=10){ // y ++
      int loc = x+y*width;
       //float b = brightness(cam.pixels[loc]); // garde la luminosité du pixel dans l'image originale
       float bleu = blue(cam.pixels[loc]); // garde la luminosité du pixel dans l'image originale

      //float d = dist(x,y,width/2, height/2);
      //pixels[x+y*width] = color(d);
      
      for (int xx = 0; xx < 10; xx++){
        for (int yy = 0; yy < 10; yy++){
          if ( bleu > mouseX/2){
            pixels[xx+yy*width+loc] = color(255,225,255); // colore les 10 prochains      
        }
          else {
            pixels[xx+yy*width+loc] = color(0,0,0); 
          }
        } 
      }
    }
    
  }
  updatePixels();
  image(cam, 0, 0, 240, 160);
  
  theBlobDetection.computeBlobs(cam.pixels);
  drawBlobsAndEdges(true,true);
  
  text("ASCII : ", 20, 90);
  //image.loadPixels();
  // text("testing", 40, 40);
  
    for (int i=0;i<=7;i++){
    
      stroke(200,200,200);
  
      text(int(ladyAda[i]), (i*multiplier)+offsetX+(widthX/2)-5, 310);
      rect((i*multiplier)+offsetX,offsetY,widthX,widthY);
   
      if(ladyAda[i]==true){  
        asciiVal = int(pow(2,i))+asciiVal; 
        } 
      }
  
   text(asciiVal, 80, 90); 
 
   char c = char(asciiVal);
   text("Char : "+c, 20, 120); 
 
   if (asciiVal == 32) {  // remise à zéro lorsqu'il y a un espace code ASCII '32' 
     leMot = "";
   }
 
 // ajouter c au mot seulement s'il y a une nouvelle lettre
 if (asciiVal != vieuxAscii ){
   leMot = leMot + c;
   }
  
  text("Mot (String) : "+leMot, 20, 150);
  vieuxAscii = asciiVal;
  asciiVal = 0; // reset
  
   for(int i=0;i<=7;i++){ // reset array
      ladyAda[i]= false;
      
      }
  
} // fin de draw


// ==================================================
// drawBlobsAndEdges()
// ==================================================
void drawBlobsAndEdges(boolean drawBlobs, boolean drawEdges)
{
  
  noFill();
  Blob b;
  EdgeVertex eA,eB;
  
  for (int n=0 ; n<theBlobDetection.getBlobNb() ; n++)
  {
    b=theBlobDetection.getBlob(n);
    println("numero de blob : "+n);
    //println("theBlobDetection.getBlobNb() : "+theBlobDetection.getBlobNb());
    
    if (b!=null)
    {
       // j'ai un b à tester pour tous les cas de mes rectangles... si oui alors écrit ds ladyAda[i], sinon laisse faire
       
       for(int i=0;i<=7;i++){          
          boolean maBox = box_box(b.xMin*width, b.yMin*height, b.xMin*width+b.w*width, b.yMin*height+b.h*height, 
          (i*multiplier)+offsetX,offsetY, (i*multiplier)+offsetX+widthX, offsetY+multiplier);  // (i*70)+60,210, (i*70)+60+40, 210+70); 
          
          if(maBox == true) {
            ladyAda[i] = true;
          }
             
        }
      
      // Blobs
      if (drawBlobs)
      {
        strokeWeight(1);
        stroke(255,0,0);
        rect(b.xMin*width,b.yMin*height,b.w*width,b.h*height);
        
     } // end drawBlobs
      
    }
// countBlob = 0;
      }
      
}

boolean box_box(float ax0, float ay0, float ax1, float ay1, float bx0, float by0, float bx1, float by1){
    float topA = (float) Math.min(ay0, ay1);
    float botA = (float) Math.max(ay0, ay1);
    float leftA = (float) Math.min(ax0, ax1);
    float rightA = (float) Math.max(ax0, ax1);
    float topB = (float) Math.min(by0, by1);
    float botB = (float) Math.max(by0, by1);
    float leftB = (float) Math.min(bx0, bx1);
    float rightB = (float) Math.max(bx0, bx1);
    if(botA <= topB  || botB <= topA || rightA <= leftB || rightB <= leftA)
      return false;
    //if(botA >= topB  || botB >= topA || rightA >= leftB || rightB >= leftA)
      // return true; 
    return true;   
}
   
float[] box_box_p(float ax0, float ay0, float ax1, float ay1, float bx0, float by0, float bx1, float by1){
    float[] result = new float[0];
    float topA = (float) Math.min(ay0, ay1);
    float botA = (float) Math.max(ay0, ay1);
    float leftA = (float) Math.min(ax0, ax1);
    float rightA = (float) Math.max(ax0, ax1);
    float topB = (float) Math.min(by0, by1);
    float botB = (float) Math.max(by0, by1);
    float leftB = (float) Math.min(bx0, bx1);
    float rightB = (float) Math.max(bx0, bx1);
   
    if(botA <= topB  || botB <= topA || rightA <= leftB || rightB <= leftA)
        return result;
    float leftO = (leftA < leftB) ? leftB : leftA;
    float rightO = (rightA > rightB) ? rightB : rightA;
    float botO = (botA > botB) ? botB : botA;
    float topO = (topA < topB) ? topB : topA;
    result =  new float[] {leftO, topO, rightO, botO};
    return result;
}
